; baricon.s

	GET	macros.s

	IMPORT	canvas_addhandler
	IMPORT	canvas_iconbar

	AREA	|____baricon|, CODE
	EXPORT	baricon
baricon

; r0 is ^ sprite name
; r1 is ^ click proc
; r2 is "NEWx" if the icon is a new format, x is 1->7, and inverted
;       r3 is r0 on entry to Wimp_CreateIcon

	MOV	r12,r13
	STMFD	r13!,{r4-r7,lr}
	LDR	r6,baricon_left
	TEQ	r6,r2,LSL#8		; Check "NEWx"
	MOVEQ	r2,r2,LSR#24		; Strip "NEW"
	ANDEQ	r2,r2,#&f		; We could use 0->? for completeness...
	RSBEQ	r2,r2,#0		; Negate it
	MOVNE	r2,#-1
	STR	r2,baricon_icon
	LDR	r7,[r12]
	STR	r1,baricon_clickh
	MOV	r4,r0
	MOV	r1,#CANVAS_CLICKHANDLER
	ADR	r2,baricon_handler
	LDR	r0,=canvas_iconbar
	BL	canvas_addhandler
	STR	r4,spritename
	MOV	r2,r4
	MOV	r0,#40
	SWI	XWimp_SpriteOp
	MOVVS	r0,#34
	MOV	r0,r6
	MOV	r1,#4
	SWI	XOS_ReadModeVariable
	MOV	r3,r3,LSL r2
	MOV	r1,#5
	SWI	XOS_ReadModeVariable
	MOV	r4,r4,LSL r2
;	STR	r2,spritename
	ADR	r1,baricon_icon
	ADD	r5,r1,#12
	STMIA	r5,{r3,r4}
	MOV	r0,r7
	SWI	XWimp_CreateIcon
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

baricon_icon
	DCD	-1
	DCD	0,0
baricon_size
	DCD	0,0
	DCD	&17003102
spritename
	DCD	0,1,12

baricon_clickh
	DCD	0

baricon_left
	=	0,"NEW"

baricon_handler
	LDR	r0,[r1,#16]
	LDR	r1,baricon_clickh
	TEQ	r1,#0
	MOVNE	pc,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	END
